#include "DxLib.h"
#include <fstream>

#define PI	3.1415926535897932384626433832795f

// O[oϐ>_<
int gPacman[10];			// pbN}̃OtBbNnh
int gMapChip[10];			// }bv`bṽnh
int gMap[30][32];			// }bvf[^
int gScore;					// _
int gBg;					// wiOtBbNnh

// 摜̓ǂݍ
int LoadData()
{
// 摜̓ǂݍ
	if(LoadDivGraph("pacman.bmp",10, 10, 1, 48, 48, gPacman)==-1) {
		MessageBox(NULL,"pacman.bmp","ReadError",MB_OK);
		return -1;
	}
	if(LoadDivGraph("mapchip1.bmp", 5, 5, 1, 16, 16, gMapChip)==-1) {
		MessageBox(NULL,"mapchip1.bmp","ReadError",MB_OK);
		return -1;
	}
	gBg = LoadGraph("bg1.jpg");

	return 0;
}

// }bv̓ǂݍ
int MapInit()
{
	int FileHandle = FileRead_open("StageData.txt");		// t@C̃I[v
	int FileSize = FileRead_size("StageData.txt");			// t@CTCY擾
	char* FileImage = new char[FileSize];					// ̑傫̈m
	FileRead_read( FileImage,FileSize,FileHandle);			// Cǂ
	FileRead_close(FileHandle);								// t@CďI

	const char* d = FileImage;
	int sx=0,sy=0;
	int o;

	while(*d != '\0'){ // NULLiI[jł͂Ȃ
		switch( *d ){
			case ' ':	o = 0; break;
			case 'o':	o = 1; break;
			case '@':	o = 2; break;
			case '#':	o = 3; break;
			case '=':	o = 4; break;
			case '\n':
				sy ++;		// sցA[
				sx = 0;		// throw down
			default:	o = 5; break;
		}
		d++;
		if( o != 5 ){
			gMap[sy][sx]=o;	// }bv񏑂
			sx++;
		}
	}
	return 0;
}

// 
int Init()
{
	ChangeWindowMode(TRUE);
	if(DxLib_Init() == -1) return -1;

	SetDrawScreen( DX_SCREEN_BACK);		// ʂɏ݂܂錾

	if(LoadData()==-1) {
		DxLib_End();
		return -1;
	}
	MapInit();

	// Q[̐ݒ
	gScore = 0;
	return 0;
}
void ClearEvent()
{
	MessageBox(NULL,"߂ł","Congratulation",MB_OK);
	return;
}
// }bvzuit[`j
int MapSet()
{
	int sx,sy,st;
	int dot = 0;

	DrawGraph(0,0,gBg,TRUE);
	for(sy=0;sy<30;sy++){
		for(sx=0;sx<32;sx++){
			st = gMap[sy][sx];
			DrawGraph(sx*16,sy*16,gMapChip[st],TRUE);
			if(st == 1 || st == 2) dot++; 
		}
	}
	if( dot == 0 ){		// ĤׂcĂȂ
		ClearEvent();	// NAłA炢˂撣˂
		return -1;
	}
	return 0;
}

// isɕǂȂ`FbN
int CheckWall(int cx,int cy,int mx,int my)
{
	int wall = 0;
	static int dbgx=0,dbgy=0;
	if(mx!=0){
		if(gMap[cy-1][cx+mx*2]>=3) wall ++;
		if(gMap[cy  ][cx+mx*2]>=3) wall ++;
		if(gMap[cy+1][cx+mx*2]>=3) wall ++;
		dbgx=mx;dbgy=my;
	} else if(my!=0) {
		if(gMap[cy+my*2][cx-1]>=3) wall ++;
		if(gMap[cy+my*2][cx  ]>=3) wall ++;
		if(gMap[cy+my*2][cx+1]>=3) wall ++;
		dbgx=mx;dbgy=my;
	}
	
	return wall;
}
// pNjړ֐
int PakuoMove()
{
	static int key;
	static int s = 0;			// pNj\p
	static int x=15, y=19;		// }bvW
	static int dx = 0, dy = 0;	// ͗^Ȃ
	static float Angle = 0.0f;	// @
	static int mv = 0;			// pNjړ
	int mvx=0,mvy=0;

	key = GetJoypadInputState( DX_INPUT_KEY_PAD1 );
	if(key & PAD_INPUT_START) return -1;		// PAD_INPUT_START  [ESC]Key

	if(mv == 0){
		// 
		if(gMap[y][x]==1){
			// SounduςIIv
			gScore +=10;
			gMap[y][x]=0;
		}
		if(gMap[y][x]==2){
			// nCp[II
			gScore +=50;
			gMap[y][x]=0;
		}

		// ҂}XڂɂƂL[͔
		mv=16;
		if(key & PAD_INPUT_UP){
			if(!CheckWall( x, y, 0, -1)){
				dx =  0; dy = -1; Angle = PI / 2;
			}
		}else if(key & PAD_INPUT_DOWN){
			if(!CheckWall( x, y, 0, 1)){
				dx =  0; dy =  1; Angle = -PI / 2;
			}
		} else if(key & PAD_INPUT_LEFT){
			if(!CheckWall( x, y, -1, 0)){
				dx = -1; dy =  0; Angle = 0;
			}
		} else if(key & PAD_INPUT_RIGHT){
			if(!CheckWall( x, y, 1, 0)){
				dx =  1; dy =  0; Angle = PI;
			}
		} else {	// L[͂ȂƂ蔻
			if(CheckWall( x, y, dx, dy)){
				dx=0; dy=0;mv=0;
			} else {
				mv = 16;
			}
		}
	} else {
		// pNjړi}Xڂ̒ԂɂƂj
		mv-=4;
		if(mv<=0){
			x+=dx;
			y+=dy;
			mv= 0;//dx=0;dy=0;
			if(CheckWall( x, y, dx, dy)){
				dx=0; dy=0;
				mv=0;			// ÔߑΉB
			}
		} else {
			mvx=(16-mv)*dx;
			mvy=(16-mv)*dy;
		}
	}
	if((dx+dy)!=0) s = (++s)%7; // ĂƂAj[V

	DrawRotaGraph((x-1)*16+24+mvx, (y-1)*16+24+mvy, 1, Angle, gPacman[s], TRUE);

	return 0;
}
// C[v
void MainLoop()
{
	while(ProcessMessage()==0){
		ClsDrawScreen();

		if(MapSet())return;
		if(PakuoMove()) return;

		DrawFormatString(512,0,RGB(255,255,255),"SCORE:");
		DrawFormatString(512,16,RGB(255,255,255),"%6d",gScore);

		ScreenFlip();
	}
	return;
}

int WINAPI WinMain(HINSTANCE hI,HINSTANCE hP, LPSTR lpC, int nC)
{
	if(Init()) return -1;	// 

	MainLoop();				// C[`

	DxLib_End();			// Ƃ܂
	return 0;
}